import importlib
import os
import cv2 as cv
import sys
import glob
import default_vot

class Tracker:

    def __init__(self, name='atom', parameter_name='default_vot', model_dir=None, model=None):
        self.name = name
        self.parameter_name = parameter_name
        self.model = model
        self.model_dir = model_dir

    def run_init(self, img, state):
        tracker_module = importlib.import_module('pytracking.tracker.{}'.format(self.name))
        self.parameters = self.get_parameters()
        self.tracker_class = tracker_module.get_tracker_class()
        self.parameters.tracker_name = self.name
        self.parameters.param_name = self.parameter_name
        self.tracker = self.tracker_class(self.parameters)
        self.tracker.initialize(img,state)

    def run_update(self, img):
        return self.tracker.track(img)

    def get_parameters(self):
        params = default_vot.parameters(self.model_dir, self.model)
        return params



