import glob
import os
import argparse
import numpy as np
import cv2 
import json
import time
import sys 
from os.path import join, isdir, isfile
sys.path.append(os.getcwd())
import vot 
from vot import Rectangle
from Tracker import Tracker

def get_axis_aligned_bbox(region):
    try:
        region = np.array([region[0][0][0], region[0][0][1], region[0][1][0], region[0][1][1],
                           region[0][2][0], region[0][2][1], region[0][3][0], region[0][3][1]])
        region = region.tolist()    
        region = np.array([float('%.2f'%x) for x in region])
    except:
        region = np.array(region)
        
    cx = np.mean(region[0::2])
    cy = np.mean(region[1::2])
    x1 = min(region[0::2])
    x2 = max(region[0::2])
    y1 = min(region[1::2])
    y2 = max(region[1::2])
    A1 = np.linalg.norm(region[0:2] - region[2:4]) * np.linalg.norm(region[2:4] - region[4:6])
    A2 = (x2 - x1) * (y2 - y1)
    s = np.sqrt(A1 / A2)
    w = s * (x2 - x1) + 1
    h = s * (y2 - y1) + 1
    return [cx-w/2., cy-h/2., w, h]

handle = vot.VOT("polygon")
polygon = handle.region()
bbox = get_axis_aligned_bbox(polygon)
image_file = handle.frame()
# image file = 'File resource at 'b'/home/zhengpengkun/VOT2019/agility/color/00000001.jpg'''
if not image_file:
    sys.exit(0)
m = ''
for k in image_file:
    m = m + k

path = m.strip().split(' ')[-1][3:-2]
# path = '/home/zhengpengkun/VOT2019/agility/color/00000001.jpg'

im = cv2.imread(path)  # HxWxC
if len(im.shape) ==3:
    im = cv2.cvtColor(im, cv2.COLOR_BGR2RGB)

# get model
model_dir = '/home/zhengpengkun/vot-toolkit/workspace-trackyou'
model = 'trackyou.pth.tar'
tracker = Tracker(model=model, model_dir=model_dir)

# init
tracker.run_init(im, bbox)

while True:
    image_file = handle.frame()
    if not image_file:
        break
    m = ''
    for k in image_file:
        m = m + k
    path = m.strip().split(' ')[-1][3:-2]
    im = cv2.imread(path)  # HxWxC
    if len(im.shape) == 3:
        im = cv2.cvtColor(im, cv2.COLOR_BGR2RGB)
    bbox = tracker.run_update(im)  ## bbox : xmin ymin width height
    handle.report(Rectangle(bbox[0], bbox[1], bbox[2], bbox[3]))




